---
- import_tasks: secrets.yaml

- import_tasks: setup_dirs.yaml

########################################################################
### Section: prepare docker-compose

- name: copy env
  template:
    src: "env.j2"
    dest: "{{remote_path}}/env"

- name: copy postgres env
  template:
    src: "postgres.env.j2"
    dest: "{{remote_path}}/postgres.env"

- name: copy docker-compose.yaml
  template:
    src: "docker-compose.yaml.j2"
    dest: "{{remote_path}}/docker-compose.yaml"

########################################################################
### Section: bring up PostgreSQL database, then nextcloud

- name: create postgresql script directory
  ansible.builtin.file:
    path: "{{ remote_path }}/initdb"
    state: directory
    # TODO: figure out minimal permission set here
    mode: 0755

- name: deploy script to create a backup user in database
  template:
    src: "create-default-postgres-user.sh.j2"
    dest: "{{remote_path}}/initdb/create-default-postgres-user.sh"
    mode: "ugo=rx"

# Import the data from given SQL dump to the freshly deployed postgres
- import_tasks: import.yaml
  when: nextcloud_import

- name: deploy docker-compose stack
  docker_compose:
    profiles: "{{ nextcloud_docker_compose_profile }}"
    project_src: "{{remote_path}}/"
    pull: true
    remove_orphans: true

- name: wait for docker-compose stack deployment
  community.docker.docker_container_exec:
    container: "{{nextcloud_app_container_name}}"
    user: www-data
    command: php occ status --output=json
  register: _nextcloud_status_task
  changed_when: false
  retries: 180
  delay: 1
  until: _nextcloud_status_task is not failed

########################################################################
### Section: apply incremental nextcloud upgrade scripts to existing DB

- import_tasks: upgrade.yaml
  when: nextcloud_upgrade

########################################################################
### Section: now set nextcloud's config idempotently to target values

- import_tasks: initialize.yaml
  when: nextcloud_initialize

- name: query nextcloud status again to assert if it is initialized
  community.docker.docker_container_exec:
    container: "{{nextcloud_app_container_name}}"
    user: www-data
    command: php occ status --output=json
  register: _nextcloud_status_task
  changed_when: false

- name: assert that nextcloud is initialized
  assert:
    that: _nextcloud_status.installed
    msg: |
      Nextcloud is not initialized!
      Ansible somehow skipped the initialize step of the nextcloud role.
      There might be something wrong with the docker-compose stack deployment. Please check the logs.

########################################################################
### Section: additional tuning of the webserver runtime environment

- name: Update htaccess
  community.docker.docker_container_exec:
    container: "{{nextcloud_app_container_name}}"
    user: www-data
    command: php occ maintenance:update:htaccess

- import_tasks: config.yaml
  vars:
    nextcloud_config: "{{nextcloud_default_config}}"

- name: Traefik -- 
  import_tasks: traefik.yaml

- name: Custom theme -- 
  import_tasks: custom_theme.yaml
  when: nextcloud_with_custom_theme

- import_tasks: keycloak_client.yaml
  tags:
    - nextcloud_sync
  when: nextcloud_with_keycloak_client

- import_tasks: apps/user_oidc.yaml
  when: nextcloud_with_user_oidc_app
- import_tasks: apps/oidc_login.yaml
  when: nextcloud_with_oidc_login_app

- name: 'Apply the header injection patch'
  community.docker.docker_container_exec:
    container: "{{ nextcloud_app_container_name }}"
    command: /srv/header-patches/apply-patch.sh v{{nextcloud_version}}
  changed_when: not "Patch already applied" in _nextcloud_header_injection_patch.stdout
  when: nextcloud_with_header_integration
  register: _nextcloud_header_injection_patch

- import_tasks: csp_injection.yaml
  when: nextcloud_with_header_integration

- import_tasks: apps/install.yaml
  vars:
    nextcloud_install_apps: "{{nextcloud_apps}}"

# configure clamav integration
- import_tasks: configure_clamav.yaml
  when: nextcloud_with_clamav

########################################################################
### Section: configure sync service
- import_tasks: admin_app_password.yaml
  tags:
    - nextcloud_sync
  when: nextcloud_with_admin_app_password

- import_tasks: keycloak_sync.yaml
  when: nextcloud_with_keycloak_permissions_sync
  tags:
    - nextcloud_sync

########################################################################
### Section: set scheduled Cron tasks for nextcloud
- import_tasks: cron.yaml
  when: nextcloud_with_cron
